
#ifndef __SO_INTERNAL_ARCH_H__
#define __SO_INTERNAL_ARCH_H__

/* collect platform dependent code in here 
 * if we want to port it, it is at least in one place
 */
/*
static __inline__ int atomic_add_return(int i, int  *to)
{
	int __i;
	__i = i;
	__asm__ __volatile__(
	        "lock; xaddl %0, %1"
		:"+r" (i), "+m" (*to)
		: : "memory");
	return i + __i;
}
*/

static __inline__ void nop(void)
{
	__asm__ __volatile(
		"nop\n\t" 
		"pause");
}

static __inline__ char test_and_set_char(char x, char* ptr)
{    
	__asm__ __volatile__("xchgb %b0,%1"
			     :"=q" (x)
			     :"m" (*ptr), "0" (x)
			     :"memory");
	return x;
}

#endif

